/***************************************************************************
                          animatedobjects.h  -  description
                             -------------------
    begin                : Tue Jul 30 2002
    copyright            : (C) 2002 by Eugen C.
    email                : eug@thekompany.com
 ***************************************************************************/
#ifndef ANIMATEDOBJECTS_H
#define ANIMATEDOBJECTS_H

#include "fieldmap.h"

#include <qlist.h>
#include <qwidget.h>
#include <qpixmap.h>
#include <qtimer.h>

class KGrEnemy;
typedef QList<KGrEnemy> EnemiesList;
typedef QListIterator<KGrEnemy> EnemiesListIterator;

/*  
 *      __ _                      
 *     / _(_) __ _ _   _ _ __ ___ 
 *    | |_| |/ _` | | | | '__/ _ \
 *    |  _| | (_| | |_| | | |  __/
 *    |_| |_|\__, |\__,_|_|  \___|
 *           |___/                
 */

class KGrFigure : public KGrObj
{
  Q_OBJECT 

  public:
    KGrFigure(int , int );
    virtual ~KGrFigure();
    
    void setPlayfield(FieldMap * fieldMap);
    
    void incnuggetd();
    int getx();
    int gety();
    int getnuggets();
    void setNuggets(int n);
    void showFigure();
    virtual void init(int,int);
    KGrObj::Status status();
    KGrObj::Direction direction();
 
  protected:
    virtual bool canWalkRight();
    virtual bool canWalkLeft();
    virtual bool canWalkUp();
    virtual bool canWalkDown();
    virtual bool canStand();
    virtual bool hangAtPole();
    virtual bool standOnEnemy()=0;
    
    void walkUp();
    void walkDown();
    void walkRight();
    void walkLeft();
    void initFall(int);
    void eraseOldFigure();
    
    static int herox;
    static int heroy;
    
    int absx, absy;
    int relx, rely; // Figur wird um relx,rely Pixel verschoben 
    int mem_x,mem_y,mem_relx,mem_rely;
    int walkCounter;
    int nuggets;
    int actualPixmap; // ArrayPos der zu zeichnenden Pixmap
    
    int WALKDELAY;
    int FALLDELAY;
    
    QTimer *walkTimer;
    QTimer *fallTimer;
  
    FieldMap * map;
    KGrObj::Status status_;
    KGrObj::Direction direction_;
};

class KGrEnemy : public KGrFigure
{
  Q_OBJECT

  public:
    KGrEnemy(int , int );
    virtual ~KGrEnemy();
    
    void showFigure();
    void startSearching();
    void setEnemyList(EnemiesList *);
    virtual void init(int,int);
    int enemyId;
    
  private:
    int birthX, birthY;
    int CAPTIVEDELAY;
    int searchStatus;
    int captiveCounter;
    bool heroOnMyHead;
    QTimer *captiveTimer;
    QPixmap enemyPm[2][20];
    bool canWalkUp();
    EnemiesList * enemies;
    bool standOnEnemy();
    bool isInside(int,int);
    bool isInEnemy();
  
    KGrObj::Direction searchbestway(int,int,int,int);
    KGrObj::Direction searchdownway(int,int,int,int);
    KGrObj::Direction searchupway(int,int,int,int);
    KGrObj::Direction searchleftway(int,int,int,int);
    KGrObj::Direction searchrightway(int,int,int,int);
    
    void collectNugget();
    void dropNugget();
 
  public slots:
    void walkTimeDone();
    void fallTimeDone();
    void captiveTimeDone();
   
  signals:
};

class KGrHero : public KGrFigure
{
  Q_OBJECT

  public:
    KGrHero(int , int );
    virtual ~KGrHero();
    
    bool started;
    void showFigure(); 
    void dig();
    void startWalk();
    void setEnemyList(EnemiesList *);
    void init(int,int);
    void setKey( KGrObj::Direction );
    void start();
    
  private:
    EnemiesList * enemies;
    QPixmap heroPm[20];
    
    virtual bool standOnEnemy();
//    virtual bool canWalkRight();
//    virtual bool canWalkLeft();
//    virtual bool canStay();
    
    bool isInEnemy();
    bool isInside(int, int);
  
    KGrObj::Direction nextDir;
    void collectNugget();
 
  public slots:
    void walkTimeDone();
    void fallTimeDone();
 
  signals:
    void gotNugget();
    void haveAllNuggets();
    void leaveLevel();
    void caughtHero();
};

#endif
