/***************************************************************************
                          decorobjects.h  -  description
                             -------------------
    begin                : Tue Jul 30 2002
    copyright            : (C) 2002 by Eugen C.
    email                : eug@thekompany.com
 ***************************************************************************/
#ifndef DECOROBJECTS_H
#define DECOROBJECTS_H

#include <fieldmap.h>

class KGrFree : public KGrObj
{
  Q_OBJECT
  
  public:
    KGrFree(bool = true, QWidget *parent = 0, const char *name = 0);
    virtual ~KGrFree();
    
    void setNugget(bool);
};

class PseudoHero : public KGrObj
{
  Q_OBJECT
  
  public:
    PseudoHero(QWidget *parent = 0, const char *name = 0);
    virtual ~PseudoHero();
};

class PseudoEnemy : public KGrObj
{
  Q_OBJECT
  
  public:
    PseudoEnemy(QWidget *parent = 0, const char *name = 0);
    virtual ~PseudoEnemy();
};

class PseudoLadder : public KGrObj
{
  Q_OBJECT
  
  public:
    PseudoLadder(QWidget *parent = 0, const char *name = 0);
    virtual ~PseudoLadder();
};

class KGrPole : public KGrObj
{
  Q_OBJECT
  
  public:
    KGrPole(QWidget *parent = 0, const char *name = 0);
    virtual ~KGrPole();
};

class KGrStones : public KGrObj
{
  Q_OBJECT
  
  public:
    KGrStones(QWidget *parent = 0, const char *name = 0);
    virtual ~KGrStones();
};

class KGrBrick : public KGrStones
{
  Q_OBJECT
  
  public:
    KGrBrick(QWidget *parent = 0, const char *name = 0);
    virtual ~KGrBrick();
    
    void dig(void);
    void useHole();
    void unUseHole();
    
  protected slots:
    void timeDone(void);
    
  private :
    int dig_counter;
    QPixmap digpix[10];
    QTimer *timer;
};

class KGrBeton : public KGrStones
{
  Q_OBJECT
  
  public:
    KGrBeton(QWidget *parent = 0, const char *name = 0);
    virtual ~KGrBeton();
};

class KGrFbrick : public KGrStones
{
  Q_OBJECT
  
  public:
    KGrFbrick(QWidget *parent = 0, const char *name = 0);
    virtual ~KGrFbrick();
};

class KGrLadder : public KGrObj
{
  Q_OBJECT
  
  public:
    KGrLadder(QWidget *parent = 0, const char *name = 0);
    virtual ~KGrLadder();
};

class KGrHladder : public KGrLadder
{
  Q_OBJECT
  
  public:
    KGrHladder(QWidget *parent = 0, const char *name = 0);
    virtual ~KGrHladder();
    
    void showLadder();
};

#endif
