#include <qfile.h>
#include <qdir.h>

#include "dirs.h"

Dirs * Dirs::instance_ = 0L;

static const unsigned int standardDirsCount = 4;

Dirs::Dirs()
{
  qDebug("add path = %s", QPEApplication::qpeDir().latin1() );
  pathList_.append(QFile::encodeName( QPEApplication::qpeDir() ));
  
  qDebug("add path = %s", (QPEApplication::qpeDir()+"/lib/eLoadRunner").latin1() );
  pathList_.append(QFile::encodeName( QPEApplication::qpeDir()+"/lib/eLoadRunner" ));
}

Dirs::~Dirs()
{
  // Empty.
}

  QStringList
Dirs::pathList() const
{
  return Dirs::thisInstance()->pathList_;
}

  QString
Dirs::locate(const QString & name)
{
  Dirs * ad(Dirs::thisInstance());

  for
    (
      QStringList::ConstIterator it(ad->pathList_.begin());
      it != ad->pathList_.end();
      ++it
    )
  {
    QDir d(*it);

    if (d.exists(name))
      return ((*it) + "/" + name);
  }

  return QString::null;
}

  void
Dirs::prependPath(const QString & fullPath)
{
  Dirs::thisInstance()->pathList_.prepend(fullPath);
}

  void
Dirs::appendPath(const QString & fullPath)
{
  Dirs::thisInstance()->pathList_.append(fullPath);
}

  bool
Dirs::removePath(const QString & fullPath)
{
#if QT_VERSION < 300
  Dirs::thisInstance()->pathList_.remove(fullPath);
  return true;
#else
  return (0 != Dirs::thisInstance()->pathList_.remove(fullPath));
#endif
}

