/***************************************************************************
                          fieldmap.cpp  -  description
                             -------------------
    begin                : Tue Jul 30 2002
    copyright            : (C) 2002 by Eugen C
    email                : eug@thekompany.com
 ***************************************************************************/

#include "fieldmap.h"

#include <qpainter.h>

KGrObj :: KGrObj (QWidget * parent, const char *name)
  : QWidget (parent, name),
    xpos(0),
    ypos(0),
    rtti(0),
    objectSize( OBJECT_SIZE ),
    xDrawFigure_(-1),
    yDrawFigure_(-1)
{
  resize(objectSize, objectSize);
  setFixedSize(objectSize, objectSize);
  blocker = false;
}

KGrObj :: ~KGrObj ()
{
}

void KGrObj::eraseFigure (int x, int y)
{
  erase(x, y, objectSize, objectSize);
  xDrawFigure_ = yDrawFigure_ = -1;
  drawFigure_ = QPixmap();
}

void KGrObj::drawFigure (QPixmap f, int x, int y)
{
  drawFigure_ = f;
  xDrawFigure_ = x;
  yDrawFigure_ = y;
  repaint();
}

void KGrObj::init(int x, int y)
{
  xpos = x;
  ypos = y;
}

void KGrObj::setx (int x)
{
  xpos = x;
}

void KGrObj::sety (int y)
{
  ypos = y;
}

char KGrObj::whatIam ()
{
  return rtti;
}

void KGrObj::paintEvent(QPaintEvent * paintEvent)
{
  QWidget::paintEvent(paintEvent);
  
  if( xDrawFigure_ != -1 && !drawFigure_.isNull() )
    bitBlt(this, xDrawFigure_, yDrawFigure_, &drawFigure_, 0, 0, objectSize, objectSize, CopyROP, false);
}

FieldMap::FieldMap(int X, int Y)
{
  objectsX = X;
  objectsY = Y;
  
  playField = new (KGrObj**)[objectsX];
  for(int i=0; i<objectsX; i++)
    playField[i] = new (KGrObj*)[objectsY];
}

FieldMap::~FieldMap()
{
  for(int i=0; i<objectsX; i++)
  {
    if( playField[i] )
    {
      delete playField[i];
      playField[i] = 0L;
    }
  }
  
  delete playField;
}


