#ifndef QICON_LOADER_H
#define QICON_LOADER_H

#include <qpixmap.h>
#include <qiconset.h>
#include <qstring.h>
#include <qdict.h>

/**
 * QIconLoader provides icons based on name only. It knows the paths
 * to use.
 */
class QIconLoader
{
  public:

    static QIconLoader * instance()
    {
      if (0 == instance_)
        instance_ = new QIconLoader;

      return instance_;
    }

    QPixmap barIcon(const QString & name);

    QPixmap loadIcon( const QString &name, int i=0 );
    
    QString iconPath( const QString &name, int i=0 );
    
    QIconSet iconSet(const QString &name);
    
    QPixmap image(const QString &name);
    void setImage(const QString &name, QPixmap*);
    
  private:

    QIconLoader();
    ~QIconLoader();

    static QIconLoader * instance_;
    QDict<QPixmap> images_;
    QString iconsPath_;
};

/**
 * This is the usual namespace-polluting interface to QIconLoader.
 * Returns an icon set suitable for a toolbar.
 */
QPixmap BarIcon(const QString & name);

QPixmap DesktopIcon(const QString& name, int);

QPixmap SmallIcon(const QString& name);

QPixmap SmallIconSet( const QString &name );

#endif
